package com.realnet.basic.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.basic.Entity.Clients;
import com.realnet.basic.Services.ClientsService ;




@RequestMapping(value = "/token/Clients")
 @CrossOrigin("*") 
@RestController
public class tokenFree_ClientsController {
	@Autowired
	private ClientsService Service;

@Value("${projectPath}")
	private String projectPath;
 




	@PostMapping("/Clients")
		  public Clients Savedata(@RequestBody Clients data) {
		Clients save = Service.Savedata(data)	;



		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Clients/{id}")
	public  Clients update(@RequestBody Clients data,@PathVariable Integer id ) {
		Clients update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Clients/getall/page")
	public Page<Clients> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Clients> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Clients")
	public List<Clients> getdetails() {
		 List<Clients> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Clients")
	public List<Clients> getallwioutsec() {
		 List<Clients> get = Service.getdetails();		
		return get;
}
@GetMapping("/Clients/{id}")
	public  Clients  getdetailsbyId(@PathVariable Integer id ) {
		Clients  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Clients/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}





}